---
stages:
  - lint
  - build

variables:
  DEBIAN_FRONTEND: noninteractive

before_script:
  - apt-get update -qq -y && apt-get upgrade -qq -y
  - curl -sSL https://install.python-poetry.org | python3 -
  - export PATH="$HOME/.local/bin:$PATH"
  - poetry config virtualenvs.in-project true
  - poetry install

cache:
  key:
    files:
      - poetry.lock
      - .gitlab-ci.yml
    prefix: ${CI_JOB_NAME}
  paths:
    - .venv
    - .ruff_cache
    - .mypy_cache

lint:
  stage: lint
  image: python:3.11-bullseye
  script:
    - poetry run task lint

build:
  stage: build
  image: python:3.11-bullseye
  script:
    - poetry build
  artifacts:
    paths:
      - dist/
